<script>
import { defineComponent } from "vue";
export default defineComponent({
  beforeRouteEnter(to, from, next) {
    if (from.path != "/customDetail") {
      sessionStorage.removeItem("interviewListBack");
    }
    next();
  },
});
</script>

<script setup>
import { ref, watch, onMounted } from "vue";
import { raiInterface } from "@/api/api.js";
import { onBeforeRouteLeave, useRouter } from "vue-router";
import { Search } from "@element-plus/icons-vue";
import mPage from "@/components/mPage.vue";
import intervewDia from "../components/interviewDia.vue";

const router = useRouter();

const total = ref(0);
const page_no = ref(sessionStorage.getItem("interviewListBack") ? JSON.parse(sessionStorage.getItem("interviewListBack")).page_no : 1);
const pageSize = ref(10);
const search_txt = ref("");
const tableData = ref([]);
const diaTit = ref("");
const isShowDia = ref(false);
const status = ref("");
const applyId = ref("");
const itemObj = ref([]);

watch(
  () => search_txt,
  () => {
    page_no.value = 1;
    getTableData();
  }
);

/* 获取表格数据 */
const getTableData = () => {
  raiInterface
    .interviewList({
      PageSize: pageSize.value,
      CurrentIndex: page_no.value,
      KeyWord: search_txt.value,
    })
    .then((res) => {
      if (res.Ret === 200) {
        tableData.value = res.Data.List || [];
        total.value = res.Data.Paging.Totals;
      }
    });
};

/* 页码改变 */
const handleCurrentChange = (page) => {
  page_no.value = page;
  getTableData();
};

/* 操作事件 */
const dialogHandle = (item, type) => {
  diaTit.value = type;
  status.value = item.Status;
  applyId.value = item.InterviewApplyId;
  itemObj.value = type === "detail" ? [item] : [];
  isShowDia.value = true;
};
/* 操作完成 */
const diaOverHandle = () => {
  isShowDia.value = false;
  getTableData();
};

onMounted(() => {
  if (sessionStorage.getItem("interviewListBack")) {
    let backData = JSON.parse(sessionStorage.getItem("interviewListBack"));
    search_txt.value = backData.keyword;
    page_no.value = backData.page_no;
  }
  getTableData();
});

onBeforeRouteLeave((to, from, next) => {
  let backData = {
    page_no: page_no.value,
    keyword: search_txt.value,
  };
  sessionStorage.setItem("interviewListBack", JSON.stringify(backData));
  next();
});
</script>

<template>
  <div class="interviewList_container">
    <div class="interviewList_top">
      <el-input placeholder="姓名/手机号" v-model="search_txt" clearable style="max-width: 500px">
        <template #prefix>
          <el-icon class="el-input__icon"><search /></el-icon>
        </template>
      </el-input>
    </div>
    <div class="interviewList_cont">
      <el-table ref="userTable" :data="tableData" v-loading="isShowloadding" element-loading-text="数据加载中..." border>
        <el-table-column prop="UserRealName" label="姓名" align="center">
          <template #default="scope">
            <span>{{ scope.row.UserRealName }}</span></template
          >
        </el-table-column>
        <el-table-column prop="Mobile" label="手机号" align="center">
          <template #default="scope">
            <span>{{ scope.row.Mobile }}</span></template
          >
        </el-table-column>
        <el-table-column prop="CompanyName" label="客户名称" align="center">
          <template #default="scope">
            <span
              style="color: #409eff; cursor: pointer"
              @click="
                router.push({
                  path: '/RaiDetail',
                  query: {
                    id: scope.row.CompanyId,
                  },
                })
              "
              >{{ scope.row.CompanyName }}</span
            ></template
          >
        </el-table-column>
        <el-table-column prop="SalesRealName" label="所属销售" align="center">
          <template #default="scope">
            <span>{{ scope.row.SalesRealName }}</span>
          </template>
        </el-table-column>
        <el-table-column prop="Status" label="申请状态" align="center">
          <template #default="scope">
            <span>{{ scope.row.Status }}</span>
          </template>
        </el-table-column>
        <el-table-column prop="CreateTime" label="申请时间" align="center">
          <template #default="scope">
            <span>{{ scope.row.CreateTime }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" min-width="110">
          <template #default="scope">
            <span class="editsty" style="margin-right: 10px" @click="dialogHandle(scope.row, 'detail')">查看详情</span>
            <template v-if="scope.row.Status === '待邀请' || scope.row.Status === '待访谈'">
              <span class="editsty" style="margin-right: 10px" @click="dialogHandle(scope.row, 'update')">状态更新</span>
              <span class="editsty"  @click="dialogHandle(scope.row, 'cancel')">取消</span>
            </template>
          </template>
        </el-table-column>
        <template #empty>
          <div style="lineheight: 44px; margin: 60px 0; color: #999">
            <img src="~@/assets/img/cus_m/nodata.png" alt="" style="display: block; width: 160px; height: 128px; margin: auto" />
            <span>暂无数据</span>
          </div>
        </template>
      </el-table>
      <el-col :span="24" class="toolbar">
        <m-page :total="total" :page_no="page_no" @handleCurrentChange="handleCurrentChange" />
      </el-col>
    </div>
    <!-- 弹窗操作 -->
    <intervewDia :isShowDia="isShowDia" :title="diaTit" :status="status" :itemObj="itemObj" :applyId="applyId" @cancel="isShowDia = false" @over="diaOverHandle" />
  </div>
</template>

<style lang="scss" scoped>
.interviewList_container {
  .interviewList_top {
    display: flex;
    justify-content: flex-end;
    align-items: center;
    border: 1px solid #ececec;
    padding: 20px 30px;
    background: #fff;
    border-radius: 4px;
    box-shadow: 0 3px 6px rgba(0, 0, 0, 0.05);
  }
  .interviewList_cont {
    min-height: calc(100vh - 320px);
    padding: 20px 30px 80px;
    background: #fff;
    margin-top: 20px;
    position: relative;
    border: 1px solid #ececec;
    border-radius: 4px;
    box-shadow: 0 3px 6px rgba(0, 0, 0, 0.05);
  }
}
</style>
